{
  "x-generator": "On Key REST API Docs Generator",
  "swagger": "2.0",
  "info": {
    "title": "On Key FIN  API Specification",
    "description": "Better and smarter enterprise asset management with one of the world's leading Enterprise Asset Management (EAM) systems.",
    "termsOfService": "https://www.onkey.com/",
    "contact": {
      "name": "On Key Support",
      "url": "https://www.onkey.com/",
      "email": "onkey.support@pragmaworld.net"
    },
    "license": {
      "name": "On Key Licence",
      "url": "https://www.onkey.com/"
    },
    "version": "1.0.0"
  },
  "host": "<variable>:443",
  "basePath": "/api/tenants/{client}/{connection}",
  "schemes": [
    "https"
  ],
  "consumes": [
    "application/vnd.onkey.entity+json",
    "application/vnd.onkey.entitypatch+json",
    "application/vnd.onkey.entitydelete+json",
    "application/vnd.onkey.entitycollection+json",
    "application/vnd.onkey.entitypatchcollection+json",
    "application/vnd.onkey.entitydeletecollection+json"
  ],
  "produces": [
    "application/vnd.onkey.entity+json",
    "application/vnd.onkey.notification+json",
    "application/vnd.onkey.entitycollectionpage+json",
    "application/vnd.onkey.entitycollection+json"
  ],
  "paths": {
    "/Modules/FIN/Budgets/{id}": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Get a Budget resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Budget->Code | string |  |\r\n| createdByUserId | Budget->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Budget->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Budget->CreatedByUser_FullName | string |  |\r\n| createdOn | Budget->CreatedOn | string | date-time |\r\n| modifiedByUserId | Budget->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Budget->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Budget->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Budget->ModifiedOn | string | date-time |\r\n| version | Budget->Version | integer | int32 |\r\n| permissionTreeId | Budget->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | Budget->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | Budget->PermissionTree_Description | string |  |\r\n| siteId | Budget->Site_Id | integer | int64 |\r\n| siteCode | Budget->Site_Code | string |  |\r\n| siteDescription | Budget->Site_Description | string |  |\r\n| id | Budget->Id | integer | int64 |\r\n| baseCurrencyId | Budget->BaseCurrency_Id | integer | int64 |\r\n| baseCurrencyCode | Budget->BaseCurrency_Code | string |  |\r\n| baseCurrencyDescription | Budget->BaseCurrency_Description | string |  |\r\n| budgetActualAmount | Budget->BudgetActualAmount | number | decimal |\r\n| budgetActualAmountInBaseCurrency | Budget->BudgetActualAmountInBaseCurrency | number | decimal |\r\n| budgetAmount | Budget->BudgetAmount | number | decimal |\r\n| budgetAmountInBaseCurrency | Budget->BudgetAmountInBaseCurrency | number | decimal |\r\n| budgetTemplateId | Budget->BudgetTemplate_Id | integer | int64 |\r\n| budgetTemplateCode | Budget->BudgetTemplate_Code | string |  |\r\n| budgetTemplateDescription | Budget->BudgetTemplate_Description | string |  |\r\n| budgetVarianceAmount | Budget->BudgetVarianceAmount | number | decimal |\r\n| budgetVarianceAmountInBaseCurrency | Budget->BudgetVarianceAmountInBaseCurrency | number | decimal |\r\n| conversionRate | Budget->ConversionRate | number | decimal |\r\n| currencyId | Budget->Currency_Id | integer | int64 |\r\n| currencyCode | Budget->Currency_Code | string |  |\r\n| currencyDescription | Budget->Currency_Description | string |  |\r\n| description | Budget->Description | string |  |\r\n| expression | Budget->Expression | string |  |\r\n| financialYearPeriodId | Budget->FinancialYearPeriod_Id | integer | int64 |\r\n| financialYearPeriodCode | Budget->FinancialYearPeriod_Code | string |  |\r\n| financialYearPeriodDescription | Budget->FinancialYearPeriod_Description | string |  |\r\n| financialYearPeriodFinancialYearId | Budget->FinancialYearPeriod_FinancialYear_Id | integer | int64 |\r\n| financialYearPeriodFinancialYearCode | Budget->FinancialYearPeriod_FinancialYear_Code | string |  |\r\n| financialYearPeriodFinancialYearDescription | Budget->FinancialYearPeriod_FinancialYear_Description | string |  |\r\n| notes | Budget->Notes | string |  |\r\n| sequenceNumber | Budget->SequenceNumber | integer | int32 |\r\n| status | Budget->Status | string (Allowed values: [UnderDevelopment, Open, Closed]) | enum |\r\n",
        "operationId": "GetBudget",
        "produces": [
          "application/vnd.onkey.entity+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Budget",
            "schema": {
              "$ref": "#/definitions/GetBudgetResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Budget"
        ],
        "summary": "Update an existing Budget resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Budget->Version | integer | int32 |\r\n| expression | Budget->Expression | string |  |\r\n| status | Budget->Status | string (Allowed values: [UnderDevelopment, Open, Closed]) | enum |\r\n| siteId | Budget->Site_Id | integer | int64 |\r\n| description | Budget->Description | string |  |\r\n| code | Budget->Code | string |  |\r\n| sequenceNumber | Budget->SequenceNumber | integer | int32 |\r\n| notes | Budget->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| expression | Nullable | False |  |\r\n| description | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n\r\n",
        "operationId": "UpdateBudget",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/UpdateBudgetResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Budget was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Budget"
        ],
        "summary": "Delete an existing Budget resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Budget->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "DeleteBudget",
        "consumes": [
          "application/vnd.onkey.entitydelete+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "delete",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/DeleteBudgetResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Budget was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budgets": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Get a collection of Budget resources.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Budget->Version | integer | int32 |\r\n| id | Budget->Id | integer | int64 |\r\n| code | Budget->Code | string |  |\r\n| financialYearPeriodCode | Budget->FinancialYearPeriod_Code | string |  |\r\n| financialYearPeriodDescription | Budget->FinancialYearPeriod_Description | string |  |\r\n| financialYearPeriodFinancialYearCode | Budget->FinancialYearPeriod_FinancialYear_Code | string |  |\r\n| financialYearPeriodFinancialYearDescription | Budget->FinancialYearPeriod_FinancialYear_Description | string |  |\r\n| budgetAmount | Budget->BudgetAmount | number | decimal |\r\n| budgetActualAmount | Budget->BudgetActualAmount | number | decimal |\r\n| budgetVarianceAmount | Budget->BudgetVarianceAmount | number | decimal |\r\n| budgetAmountInBaseCurrency | Budget->BudgetAmountInBaseCurrency | number | decimal |\r\n| budgetActualAmountInBaseCurrency | Budget->BudgetActualAmountInBaseCurrency | number | decimal |\r\n| budgetVarianceAmountInBaseCurrency | Budget->BudgetVarianceAmountInBaseCurrency | number | decimal |\r\n| currencyCode | Budget->Currency_Code | string |  |\r\n| currencyDescription | Budget->Currency_Description | string |  |\r\n| baseCurrencyCode | Budget->BaseCurrency_Code | string |  |\r\n| baseCurrencyDescription | Budget->BaseCurrency_Description | string |  |\r\n| createdOn | Budget->CreatedOn | string | date-time |\r\n| modifiedOn | Budget->ModifiedOn | string | date-time |\r\n",
        "operationId": "GetBudgetCollection",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Budget collection",
            "schema": {
              "$ref": "#/definitions/GetBudgetCollectionResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "post": {
        "tags": [
          "Budget"
        ],
        "summary": "Create a new Budget resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Budget->Code | string |  |\r\n| permissionTreeId | Budget->PermissionTree_Id | integer | int64 |\r\n| financialYearPeriodId | Budget->FinancialYearPeriod_Id | integer | int64 |\r\n| expression | Budget->Expression | string |  |\r\n| currencyId | Budget->Currency_Id | integer | int64 |\r\n| budgetAmount | Budget->BudgetAmount | number | decimal |\r\n| budgetTemplateId | Budget->BudgetTemplate_Id | integer | int64 |\r\n| description | Budget->Description | string |  |\r\n| siteId | Budget->Site_Id | integer | int64 |\r\n| sequenceNumber | Budget->SequenceNumber | integer | int32 |\r\n| notes | Budget->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| permissionTreeId | System Generated | true | If no value specified |\r\n| permissionTreeId | Nullable | False |  |\r\n| financialYearPeriodId | Required | True |  |\r\n| financialYearPeriodId | Nullable | False |  |\r\n| expression | Required | True |  |\r\n| expression | Nullable | False |  |\r\n| currencyId | Required | True |  |\r\n| currencyId | Nullable | False |  |\r\n| budgetAmount | Required | True |  |\r\n| budgetAmount | Nullable | False |  |\r\n| budgetAmount | Min Value | >= 0|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n\r\n",
        "operationId": "CreateBudget",
        "consumes": [
          "application/vnd.onkey.entity+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "post",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/CreateBudgetResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - resource was successfully created",
            "headers": {
              "OnKey-Resource-Id": {
                "type": "integer",
                "description": "Id of the resource created",
                "format": "Int64"
              },
              "OnKey-Resource-Location": {
                "type": "string",
                "description": "Uri to fetch the created resource"
              }
            }
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Lookups/LookupBudgetBudgetTemplate": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Lookup the Budget Template for the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | BudgetTemplate->Id | integer | int64 |\r\n| code | BudgetTemplate->Code | string |  |\r\n| description | BudgetTemplate->Description | string |  |\r\n| expression | BudgetTemplate->Expression | string |  |\r\n| budgetAmount | BudgetTemplate->BudgetAmount | number | decimal |\r\n",
        "operationId": "LookupBudgetBudgetTemplate",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Budget Template collection",
            "schema": {
              "$ref": "#/definitions/BudgetBudgetTemplateLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Lookups/LookupBudgetChangePermissionTree": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Lookup the permission set for changing the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupBudgetChangePermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/BudgetChangePermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Lookups/LookupBudgetCurrency": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Lookup the Currency for the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Currency->Id | integer | int64 |\r\n| code | Currency->Code | string |  |\r\n| description | Currency->Description | string |  |\r\n",
        "operationId": "LookupBudgetCurrency",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Currency collection",
            "schema": {
              "$ref": "#/definitions/BudgetCurrencyLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Lookups/LookupBudgetFinancialYear": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Lookup the Financial Year for the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | FinancialYear->Id | integer | int64 |\r\n| code | FinancialYear->Code | string |  |\r\n| description | FinancialYear->Description | string |  |\r\n",
        "operationId": "LookupBudgetFinancialYear",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Financial Year collection",
            "schema": {
              "$ref": "#/definitions/BudgetFinancialYearLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Lookups/LookupBudgetFinancialYearPeriod": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Lookup the Financial Year Period for the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | FinancialYearPeriod->Id | integer | int64 |\r\n| code | FinancialYearPeriod->Code | string |  |\r\n| description | FinancialYearPeriod->Description | string |  |\r\n| financialYearId | FinancialYearPeriod->FinancialYear_Id | integer | int64 |\r\n| financialYearCode | FinancialYearPeriod->FinancialYear_Code | string |  |\r\n| financialYearDescription | FinancialYearPeriod->FinancialYear_Description | string |  |\r\n",
        "operationId": "LookupBudgetFinancialYearPeriod",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Financial Year Period collection",
            "schema": {
              "$ref": "#/definitions/BudgetFinancialYearPeriodLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Lookups/LookupBudgetInsertPermissionTree": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Lookup the permission set for creating the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupBudgetInsertPermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/BudgetInsertPermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Lookups/LookupBudgetSite": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Lookup the Site for the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Site->Id | integer | int64 |\r\n| code | Site->Code | string |  |\r\n| description | Site->Description | string |  |\r\n| currencyId | Site->Currency_Id | integer | int64 |\r\n| currencyCode | Site->Currency_Code | string |  |\r\n| currencyDescription | Site->Currency_Description | string |  |\r\n",
        "operationId": "LookupBudgetSite",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Site collection",
            "schema": {
              "$ref": "#/definitions/BudgetSiteLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Batch/{ids}": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Get a collection of Budget resources for the set of id's.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Budget->Code | string |  |\r\n| createdByUserId | Budget->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Budget->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Budget->CreatedByUser_FullName | string |  |\r\n| createdOn | Budget->CreatedOn | string | date-time |\r\n| modifiedByUserId | Budget->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Budget->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Budget->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Budget->ModifiedOn | string | date-time |\r\n| version | Budget->Version | integer | int32 |\r\n| permissionTreeId | Budget->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | Budget->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | Budget->PermissionTree_Description | string |  |\r\n| siteId | Budget->Site_Id | integer | int64 |\r\n| siteCode | Budget->Site_Code | string |  |\r\n| siteDescription | Budget->Site_Description | string |  |\r\n| id | Budget->Id | integer | int64 |\r\n| baseCurrencyId | Budget->BaseCurrency_Id | integer | int64 |\r\n| baseCurrencyCode | Budget->BaseCurrency_Code | string |  |\r\n| baseCurrencyDescription | Budget->BaseCurrency_Description | string |  |\r\n| budgetActualAmount | Budget->BudgetActualAmount | number | decimal |\r\n| budgetActualAmountInBaseCurrency | Budget->BudgetActualAmountInBaseCurrency | number | decimal |\r\n| budgetAmount | Budget->BudgetAmount | number | decimal |\r\n| budgetAmountInBaseCurrency | Budget->BudgetAmountInBaseCurrency | number | decimal |\r\n| budgetTemplateId | Budget->BudgetTemplate_Id | integer | int64 |\r\n| budgetTemplateCode | Budget->BudgetTemplate_Code | string |  |\r\n| budgetTemplateDescription | Budget->BudgetTemplate_Description | string |  |\r\n| budgetVarianceAmount | Budget->BudgetVarianceAmount | number | decimal |\r\n| budgetVarianceAmountInBaseCurrency | Budget->BudgetVarianceAmountInBaseCurrency | number | decimal |\r\n| conversionRate | Budget->ConversionRate | number | decimal |\r\n| currencyId | Budget->Currency_Id | integer | int64 |\r\n| currencyCode | Budget->Currency_Code | string |  |\r\n| currencyDescription | Budget->Currency_Description | string |  |\r\n| description | Budget->Description | string |  |\r\n| expression | Budget->Expression | string |  |\r\n| financialYearPeriodId | Budget->FinancialYearPeriod_Id | integer | int64 |\r\n| financialYearPeriodCode | Budget->FinancialYearPeriod_Code | string |  |\r\n| financialYearPeriodDescription | Budget->FinancialYearPeriod_Description | string |  |\r\n| financialYearPeriodFinancialYearId | Budget->FinancialYearPeriod_FinancialYear_Id | integer | int64 |\r\n| financialYearPeriodFinancialYearCode | Budget->FinancialYearPeriod_FinancialYear_Code | string |  |\r\n| financialYearPeriodFinancialYearDescription | Budget->FinancialYearPeriod_FinancialYear_Description | string |  |\r\n| notes | Budget->Notes | string |  |\r\n| sequenceNumber | Budget->SequenceNumber | integer | int32 |\r\n| status | Budget->Status | string (Allowed values: [UnderDevelopment, Open, Closed]) | enum |\r\n",
        "operationId": "BatchGetBudget",
        "produces": [
          "application/vnd.onkey.entitycollection+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "array",
            "name": "ids",
            "in": "path",
            "required": true,
            "description": "A comma separated list of Budget id's (eg. 1585760985950002,1585760985950003)",
            "collectionFormat": "csv",
            "x-nullable": false,
            "items": {
              "type": "integer",
              "format": "int64"
            }
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Budget collection",
            "schema": {
              "$ref": "#/definitions/BatchGetBudgetResourceAction"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Batch": {
      "post": {
        "tags": [
          "Budget"
        ],
        "summary": "Create a new collection of Budget resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Budget->Code | string |  |\r\n| permissionTreeId | Budget->PermissionTree_Id | integer | int64 |\r\n| financialYearPeriodId | Budget->FinancialYearPeriod_Id | integer | int64 |\r\n| expression | Budget->Expression | string |  |\r\n| currencyId | Budget->Currency_Id | integer | int64 |\r\n| budgetAmount | Budget->BudgetAmount | number | decimal |\r\n| budgetTemplateId | Budget->BudgetTemplate_Id | integer | int64 |\r\n| description | Budget->Description | string |  |\r\n| siteId | Budget->Site_Id | integer | int64 |\r\n| sequenceNumber | Budget->SequenceNumber | integer | int32 |\r\n| notes | Budget->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| permissionTreeId | System Generated | true | If no value specified |\r\n| permissionTreeId | Nullable | False |  |\r\n| financialYearPeriodId | Required | True |  |\r\n| financialYearPeriodId | Nullable | False |  |\r\n| expression | Required | True |  |\r\n| expression | Nullable | False |  |\r\n| currencyId | Required | True |  |\r\n| currencyId | Nullable | False |  |\r\n| budgetAmount | Required | True |  |\r\n| budgetAmount | Nullable | False |  |\r\n| budgetAmount | Min Value | >= 0|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchCreateBudget",
        "consumes": [
          "application/vnd.onkey.entitycollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "posts",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchCreateBudgetResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - Budget batch was successfully created"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Budget"
        ],
        "summary": "Update a collection of existing Budget resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Budget->Id | integer | int64 |\r\n| version | Budget->Version | integer | int32 |\r\n| expression | Budget->Expression | string |  |\r\n| status | Budget->Status | string (Allowed values: [UnderDevelopment, Open, Closed]) | enum |\r\n| siteId | Budget->Site_Id | integer | int64 |\r\n| description | Budget->Description | string |  |\r\n| code | Budget->Code | string |  |\r\n| sequenceNumber | Budget->SequenceNumber | integer | int32 |\r\n| notes | Budget->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| expression | Nullable | False |  |\r\n| description | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchUpdateBudget",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchUpdateBudgetResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Budget batch was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Budget"
        ],
        "summary": "Delete a collection of existing Budget resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Budget->Id | integer | int64 |\r\n| version | Budget->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchDeleteBudget",
        "consumes": [
          "application/vnd.onkey.entitydeletecollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "deletes",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchDeleteBudgetResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Budget batch was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budgets/BudgetAmount/Batch": {
      "patch": {
        "tags": [
          "Budget"
        ],
        "summary": "Batch Set Budget Amount",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | SetBudgetAmount->Id | integer | int64 |\r\n| version | SetBudgetAmount->Version | integer | int32 |\r\n| budgetAmount | SetBudgetAmount->BudgetAmount | number | decimal |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| budgetAmount | Required | True |  |\r\n| budgetAmount | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchSetBudgetAmount",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchSetBudgetAmountResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budgets/{id}/PermissionTree": {
      "patch": {
        "tags": [
          "Budget"
        ],
        "summary": "Change the PermissionTree for an existing Budget resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Budget->Version | integer | int32 |\r\n| permissionTreeId | Budget->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeBudgetPermissionTree",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/ChangeBudgetPermissionTreeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budgets/{id}/BudgetAmount": {
      "patch": {
        "tags": [
          "Budget"
        ],
        "summary": "Set Budget Amount",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | SetBudgetAmount->Version | integer | int32 |\r\n| budgetAmount | SetBudgetAmount->BudgetAmount | number | decimal |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| budgetAmount | Required | True |  |\r\n| budgetAmount | Nullable | False |  |\r\n\r\n",
        "operationId": "SetBudgetAmount",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/SetBudgetAmountResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Batch/PermissionTree": {
      "patch": {
        "tags": [
          "Budget"
        ],
        "summary": "Change the PermissionTree status for a collection of existing Budget resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Budget->Id | integer | int64 |\r\n| version | Budget->Version | integer | int32 |\r\n| permissionTreeId | Budget->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeBudgetPermissionTree",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchChangeBudgetPermissionTreeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/{id}": {
      "get": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Get a Budget Parameter resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| isActive | BudgetParameter->IsActive | boolean |  |\r\n| createdByUserId | BudgetParameter->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | BudgetParameter->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | BudgetParameter->CreatedByUser_FullName | string |  |\r\n| createdOn | BudgetParameter->CreatedOn | string | date-time |\r\n| modifiedByUserId | BudgetParameter->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | BudgetParameter->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | BudgetParameter->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | BudgetParameter->ModifiedOn | string | date-time |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| permissionTreeId | BudgetParameter->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | BudgetParameter->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | BudgetParameter->PermissionTree_Description | string |  |\r\n| id | BudgetParameter->Id | integer | int64 |\r\n| budgetId | BudgetParameter->Budget_Id | integer | int64 |\r\n| budgetBudgetAmount | BudgetParameter->Budget_BudgetAmount | number | decimal |\r\n| budgetCurrencyId | BudgetParameter->Budget_Currency_Id | integer | int64 |\r\n| budgetCurrencyCode | BudgetParameter->Budget_Currency_Code | string |  |\r\n| budgetCurrencyDescription | BudgetParameter->Budget_Currency_Description | string |  |\r\n| budgetFinancialYearPeriodId | BudgetParameter->Budget_FinancialYearPeriod_Id | integer | int64 |\r\n| budgetFinancialYearPeriodCode | BudgetParameter->Budget_FinancialYearPeriod_Code | string |  |\r\n| budgetFinancialYearPeriodDescription | BudgetParameter->Budget_FinancialYearPeriod_Description | string |  |\r\n| budgetFinancialYearPeriodFinancialYearId | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Id | integer | int64 |\r\n| budgetFinancialYearPeriodFinancialYearCode | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Code | string |  |\r\n| budgetFinancialYearPeriodFinancialYearDescription | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Description | string |  |\r\n| notes | BudgetParameter->Notes | string |  |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| sequenceNumber | BudgetParameter->SequenceNumber | integer | int32 |\r\n| value | BudgetParameter->Value | object | composite |\r\n",
        "operationId": "GetBudgetParameter",
        "produces": [
          "application/vnd.onkey.entity+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Parameter Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Budget Parameter",
            "schema": {
              "$ref": "#/definitions/GetBudgetParameterResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Update an existing Budget Parameter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| value | BudgetParameter->Value | object | composite |\r\n| sequenceNumber | BudgetParameter->SequenceNumber | integer | int32 |\r\n| notes | BudgetParameter->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| parameterName | Nullable | False |  |\r\n| parameterName | Min Length | >= 1 chars|  |\r\n| parameterName | Max Length | <= 50 chars|  |\r\n| value | Nullable | False |  |\r\n\r\n",
        "operationId": "UpdateBudgetParameter",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Parameter Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/UpdateBudgetParameterResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Budget Parameter was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Delete an existing Budget Parameter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "DeleteBudgetParameter",
        "consumes": [
          "application/vnd.onkey.entitydelete+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Parameter Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "input",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/DeleteBudgetParameterResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Budget Parameter was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters": {
      "get": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Get a collection of Budget Parameter resources.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| id | BudgetParameter->Id | integer | int64 |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| isActive | BudgetParameter->IsActive | boolean |  |\r\n| sequenceNumber | BudgetParameter->SequenceNumber | integer | int32 |\r\n| value | BudgetParameter->Value | object | composite |\r\n| budgetId | BudgetParameter->Budget_Id | integer | int64 |\r\n| budgetFinancialYearPeriodCode | BudgetParameter->Budget_FinancialYearPeriod_Code | string |  |\r\n| budgetFinancialYearPeriodDescription | BudgetParameter->Budget_FinancialYearPeriod_Description | string |  |\r\n| budgetFinancialYearPeriodFinancialYearCode | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Code | string |  |\r\n| budgetFinancialYearPeriodFinancialYearDescription | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Description | string |  |\r\n",
        "operationId": "GetBudgetParameterCollection",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Budget Parameter collection",
            "schema": {
              "$ref": "#/definitions/GetBudgetParameterCollectionResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "post": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Create a new Budget Parameter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| permissionTreeId | BudgetParameter->PermissionTree_Id | integer | int64 |\r\n| value | BudgetParameter->Value | object | composite |\r\n| budgetId | BudgetParameter->Budget_Id | integer | int64 |\r\n| sequenceNumber | BudgetParameter->SequenceNumber | integer | int32 |\r\n| notes | BudgetParameter->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| parameterName | Required | True |  |\r\n| parameterName | Nullable | False |  |\r\n| parameterName | Min Length | >= 1 chars|  |\r\n| parameterName | Max Length | <= 50 chars|  |\r\n| permissionTreeId | System Generated | true | If no value specified |\r\n| permissionTreeId | Nullable | False |  |\r\n| value | Required | True |  |\r\n| value | Nullable | False |  |\r\n| budgetId | Required | True |  |\r\n| budgetId | Nullable | False |  |\r\n\r\n",
        "operationId": "CreateBudgetParameter",
        "consumes": [
          "application/vnd.onkey.entity+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "post",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/CreateBudgetParameterResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - resource was successfully created",
            "headers": {
              "OnKey-Resource-Id": {
                "type": "integer",
                "description": "Id of the resource created",
                "format": "Int64"
              },
              "OnKey-Resource-Location": {
                "type": "string",
                "description": "Uri to fetch the created resource"
              }
            }
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budgets/{budgetId}/Parameters": {
      "get": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Get a collection of Budget Parameter resources for the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | BudgetParameter->Id | integer | int64 |\r\n| budgetId | BudgetParameter->Budget_Id | integer | int64 |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| value | BudgetParameter->Value | object | composite |\r\n| isActive | BudgetParameter->IsActive | boolean |  |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n",
        "operationId": "GetBudgetParameterForBudgetCollection",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "budgetId",
            "in": "path",
            "required": true,
            "description": "Budget Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Budget Parameter collection",
            "schema": {
              "$ref": "#/definitions/GetBudgetParameterForBudgetCollectionResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/Lookups/LookupBudgetParameterChangePermissionTree": {
      "get": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Lookup the permission set for changing the Budget Parameter.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupBudgetParameterChangePermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/BudgetParameterChangePermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/Lookups/LookupBudgetParameterInsertPermissionTree": {
      "get": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Lookup the permission set for creating the Budget Parameter.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupBudgetParameterInsertPermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/BudgetParameterInsertPermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/Lookups/LookupBudgetParameterBudget": {
      "get": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Lookup the Budget for the Budget Parameter.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Budget->Id | integer | int64 |\r\n| currencyCode | Budget->Currency_Code | string |  |\r\n| currencyDescription | Budget->Currency_Description | string |  |\r\n| budgetAmount | Budget->BudgetAmount | number | decimal |\r\n| financialYearPeriodCode | Budget->FinancialYearPeriod_Code | string |  |\r\n| financialYearPeriodDescription | Budget->FinancialYearPeriod_Description | string |  |\r\n| financialYearPeriodFinancialYearCode | Budget->FinancialYearPeriod_FinancialYear_Code | string |  |\r\n| financialYearPeriodFinancialYearDescription | Budget->FinancialYearPeriod_FinancialYear_Description | string |  |\r\n| expression | Budget->Expression | string |  |\r\n",
        "operationId": "LookupBudgetParameterBudget",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Budget collection",
            "schema": {
              "$ref": "#/definitions/BudgetParametersChangeDataTriggerLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/Batch/{ids}": {
      "get": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Get a collection of Budget Parameter resources for the set of id's.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| isActive | BudgetParameter->IsActive | boolean |  |\r\n| createdByUserId | BudgetParameter->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | BudgetParameter->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | BudgetParameter->CreatedByUser_FullName | string |  |\r\n| createdOn | BudgetParameter->CreatedOn | string | date-time |\r\n| modifiedByUserId | BudgetParameter->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | BudgetParameter->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | BudgetParameter->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | BudgetParameter->ModifiedOn | string | date-time |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| permissionTreeId | BudgetParameter->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | BudgetParameter->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | BudgetParameter->PermissionTree_Description | string |  |\r\n| id | BudgetParameter->Id | integer | int64 |\r\n| budgetId | BudgetParameter->Budget_Id | integer | int64 |\r\n| budgetBudgetAmount | BudgetParameter->Budget_BudgetAmount | number | decimal |\r\n| budgetCurrencyId | BudgetParameter->Budget_Currency_Id | integer | int64 |\r\n| budgetCurrencyCode | BudgetParameter->Budget_Currency_Code | string |  |\r\n| budgetCurrencyDescription | BudgetParameter->Budget_Currency_Description | string |  |\r\n| budgetFinancialYearPeriodId | BudgetParameter->Budget_FinancialYearPeriod_Id | integer | int64 |\r\n| budgetFinancialYearPeriodCode | BudgetParameter->Budget_FinancialYearPeriod_Code | string |  |\r\n| budgetFinancialYearPeriodDescription | BudgetParameter->Budget_FinancialYearPeriod_Description | string |  |\r\n| budgetFinancialYearPeriodFinancialYearId | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Id | integer | int64 |\r\n| budgetFinancialYearPeriodFinancialYearCode | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Code | string |  |\r\n| budgetFinancialYearPeriodFinancialYearDescription | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Description | string |  |\r\n| notes | BudgetParameter->Notes | string |  |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| sequenceNumber | BudgetParameter->SequenceNumber | integer | int32 |\r\n| value | BudgetParameter->Value | object | composite |\r\n",
        "operationId": "BatchGetBudgetParameter",
        "produces": [
          "application/vnd.onkey.entitycollection+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "array",
            "name": "ids",
            "in": "path",
            "required": true,
            "description": "A comma separated list of Budget Parameter id's (eg. 1585760985950002,1585760985950003)",
            "collectionFormat": "csv",
            "x-nullable": false,
            "items": {
              "type": "integer",
              "format": "int64"
            }
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Budget Parameter collection",
            "schema": {
              "$ref": "#/definitions/BatchGetBudgetParameterResourceAction"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/Batch": {
      "post": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Create a new collection of Budget Parameter resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| permissionTreeId | BudgetParameter->PermissionTree_Id | integer | int64 |\r\n| value | BudgetParameter->Value | object | composite |\r\n| budgetId | BudgetParameter->Budget_Id | integer | int64 |\r\n| sequenceNumber | BudgetParameter->SequenceNumber | integer | int32 |\r\n| notes | BudgetParameter->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| parameterName | Required | True |  |\r\n| parameterName | Nullable | False |  |\r\n| parameterName | Min Length | >= 1 chars|  |\r\n| parameterName | Max Length | <= 50 chars|  |\r\n| permissionTreeId | System Generated | true | If no value specified |\r\n| permissionTreeId | Nullable | False |  |\r\n| value | Required | True |  |\r\n| value | Nullable | False |  |\r\n| budgetId | Required | True |  |\r\n| budgetId | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchCreateBudgetParameter",
        "consumes": [
          "application/vnd.onkey.entitycollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "posts",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchCreateBudgetParameterRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - Budget Parameter batch was successfully created"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Update a collection of existing Budget Parameter resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | BudgetParameter->Id | integer | int64 |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| value | BudgetParameter->Value | object | composite |\r\n| sequenceNumber | BudgetParameter->SequenceNumber | integer | int32 |\r\n| notes | BudgetParameter->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| parameterName | Nullable | False |  |\r\n| parameterName | Min Length | >= 1 chars|  |\r\n| parameterName | Max Length | <= 50 chars|  |\r\n| value | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchUpdateBudgetParameter",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchUpdateBudgetParameterResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Budget Parameter batch was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Delete a collection of existing Budget Parameter resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | BudgetParameter->Id | integer | int64 |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchDeleteBudgetParameter",
        "consumes": [
          "application/vnd.onkey.entitydeletecollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "deletes",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchDeleteBudgetParameterResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Budget Parameter batch was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/{id}/Active": {
      "patch": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Change the IsActive status for an existing Budget Parameter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| isActive | BudgetParameter->IsActive | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| isActive | Required | True |  |\r\n| isActive | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeBudgetParameterIsActive",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Parameter Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/ChangeBudgetParameterIsActiveResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/{id}/PermissionTree": {
      "patch": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Change the PermissionTree for an existing Budget Parameter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| permissionTreeId | BudgetParameter->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeBudgetParameterPermissionTree",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Parameter Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/ChangeBudgetParameterPermissionTreeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/Batch/Active": {
      "patch": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Change the IsActive status for a collection of existing Budget Parameter resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | BudgetParameter->Id | integer | int64 |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| isActive | BudgetParameter->IsActive | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| isActive | Required | True |  |\r\n| isActive | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeBudgetParameterIsActive",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
[...]
